The Status Bar appears below the grid and contains Status Bar Panels. Panels can be Grid Provided Panels or Custom Status Bar Panels.
Configure the Status Bar with the statusBar grid property. The property takes a list of Status Bar Panels.
const gridOptions = {
statusBar: {
statusPanels: [
{ statusPanel: 'agTotalAndFilteredRowCountComponent' },
{ statusPanel: 'agTotalRowCountComponent' },
{ statusPanel: 'agFilteredRowCountComponent' },
{ statusPanel: 'agSelectedRowCountComponent' },
{ statusPanel: 'agAggregationComponent' }
]
},
// other grid options ...
}Some Status Panels only show when a Cell Selection is present.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
NumberFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", minWidth: 200 },
{ field: "age", filter: "agNumberColumnFilter" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
filter: true,
},
rowSelection: { mode: "multiRow" },
cellSelection: true,
statusBar: {
statusPanels: [
{ statusPanel: "agTotalAndFilteredRowCountComponent" },
{ statusPanel: "agTotalRowCountComponent" },
{ statusPanel: "agFilteredRowCountComponent" },
{ statusPanel: "agSelectedRowCountComponent" },
{ statusPanel: "agAggregationComponent" },
],
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Provided Panels Copy Link
The Status Bar Panels provided by the grid are as follows:
agTotalRowCountComponent: Provides the total row count.agTotalAndFilteredRowCountComponent: Provides the total and filtered row count.agFilteredRowCountComponent: Provides the filtered row count.agSelectedRowCountComponent: Provides the selected row count.agAggregationComponent: Provides aggregations on the selected range.
Configuration Copy Link
The align property can be left, center or right (default).
The key is used for Accessing Panel Instances via the grid API getStatusPanel(key). This can be useful for interacting with Custom Panels.
Additional props are passed to Status Panels using statusPanelParams. The provided panel agAggregationComponent can have aggFuncs passed.
const gridOptions = {
statusBar: {
statusPanels: [
{
key: 'aUniqueString',
statusPanel: 'agTotalRowCountComponent',
align: 'left'
},
{
statusPanel: 'agAggregationComponent',
statusPanelParams: {
// possible values are: 'count', 'sum', 'min', 'max', 'avg'
aggFuncs: ['avg', 'sum']
}
}
]
},
// other grid options ...
}Labels (e.g. "Rows", "Total Rows", "Average") and number formatting are changed using the grid's Localisation.
The Aggregation Panel agAggregationComponent works with number and bigint values. When bigint values are present, avg uses integer division and discards the fractional part.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
statusBar: {
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["avg", "sum"],
},
},
],
},
cellSelection: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The Status Bar sizes its height to fit content. When no panels are visible, the Status Bar will have zero height (not be shown). Add CSS to have a fixed height on the Status Bar.
.ag-status-bar {
min-height: 35px;
} Value Formatting Copy Link
Each Status Bar Panel can have its displayed values customised using a valueFormatter function. This allows for formatting values before they are rendered in the UI.
The valueFormatter function is provided in the statusPanelParams object.
const gridOptions = {
statusBar: {
statusPanels: [
{
statusPanel: 'agTotalAndFilteredRowCountComponent',
statusPanelParams: {
valueFormatter: (statusPanelValueFormatterParams) => {
const { value } = statusPanelValueFormatterParams;
if (value > 1000) {
return value / 1000 + ' K';
}
return String(value);
}
}
},
]
},
// other grid options ...
} IProvidedStatusPanelParams Copy Link
Properties available on the IProvidedStatusPanelParams interface.
(params: IStatusPanelValueFormatterParams) => string |
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
IStatusPanelValueFormatterParams,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
statusBar: {
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
statusPanelParams: {
valueFormatter: (params: IStatusPanelValueFormatterParams) => {
const { value, bigintValue } = params;
if (bigintValue != null) {
return bigintValue.toString();
}
if (typeof value === "number" && value > 1000) {
return (value / 1000).toFixed(1) + " K";
}
return String(value);
},
},
},
],
},
cellSelection: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Custom Panels Copy Link
Applications that are using Server-side Data or which require bespoke Status Bar Panels can provide their own custom Status Bar panels.
Clicking on the button in the status bar will log the number of selected rows to the developer console.
import {
ClientSideRowModelModule,
ColDef,
EventApiModule,
GridApi,
GridOptions,
IAggregationStatusPanelParams,
ModuleRegistry,
RowApiModule,
RowSelectionModule,
TextEditorModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { ClickableStatusBarComponent } from "./clickableStatusBarComponent";
import { CountStatusBarComponent } from "./countStatusBarComponent";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
RowApiModule,
EventApiModule,
]);
const columnDefs: ColDef[] = [
{
field: "row",
},
{
field: "name",
},
];
let gridApi: GridApi;
const gridOptions: GridOptions = {
defaultColDef: {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
},
columnDefs: columnDefs,
rowData: [
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
],
rowSelection: {
mode: "multiRow",
},
statusBar: {
statusPanels: [
{
statusPanel: CountStatusBarComponent,
},
{
statusPanel: ClickableStatusBarComponent,
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
} as IAggregationStatusPanelParams,
},
],
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
background-color: lightgrey;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
.status-bar-input {
height: initial !important;
}
import type { IStatusPanelComp, IStatusPanelParams } from 'ag-grid-community';
export class ClickableStatusBarComponent implements IStatusPanelComp {
params!: IStatusPanelParams;
eGui!: HTMLDivElement;
eButton!: HTMLButtonElement;
buttonListener: any;
init(params: IStatusPanelParams) {
this.params = params;
this.eGui = document.createElement('div');
this.eGui.className = 'ag-status-name-value';
const label = document.createElement('span');
label.textContent = 'Status Bar Component ';
this.eGui.appendChild(label);
this.eButton = document.createElement('button');
this.buttonListener = this.onButtonClicked.bind(this);
this.eButton.addEventListener('click', this.buttonListener);
this.eButton.textContent = 'Click Me';
this.eGui.appendChild(this.eButton);
}
getGui() {
return this.eGui;
}
destroy() {
this.eButton.removeEventListener('click', this.buttonListener);
}
onButtonClicked() {
console.log('Selected Row Count: ' + this.params.api.getSelectedRows().length);
}
}
import type { IStatusPanelComp, IStatusPanelParams } from 'ag-grid-community';
export class CountStatusBarComponent implements IStatusPanelComp {
params!: IStatusPanelParams;
eGui!: HTMLDivElement;
eCount!: HTMLSpanElement;
init(params: IStatusPanelParams) {
this.params = params;
this.eGui = document.createElement('div');
this.eGui.className = 'ag-status-name-value';
const label = document.createElement('span');
label.textContent = 'Row Count Component: ';
this.eGui.appendChild(label);
this.eCount = document.createElement('span');
this.eCount.className = 'ag-status-name-value-value';
this.eGui.appendChild(this.eCount);
params.api.addEventListener('rowDataUpdated', this.onRowDataUpdated.bind(this));
}
getGui() {
return this.eGui;
}
destroy() {
if (!this.params.api.isDestroyed()) {
this.params.api.removeEventListener('rowDataUpdated', this.onRowDataUpdated);
}
}
onRowDataUpdated() {
this.eCount.textContent = this.params.api.getDisplayedRowCount() + '';
}
}
<div id="myGrid" style="height: 100%"></div>
Implement this interface to create a status bar component.
interface IStatusPanelComp {
// mandatory methods
// Return the DOM element of your component, this is what the grid puts into the DOM.
getGui(): HTMLElement;
// optional methods
// The init(params) method is called on the status bar component once.
// See below for details on the parameters.
init(params: IStatusPanelParams): void;
// Called when the `statusBar` grid option is updated.
// If this method returns `true`, the grid assumes that
// the status panel has updated with the latest params,
// and takes no further action. If this method returns `false`,
// or is not implemented, the grid will destroy and
// recreate the status panel.
refresh(params: IStatusPanelParams): boolean;
// Gets called when the grid is destroyed.
// If your status bar components needs to do any cleanup, do it here.
destroy(): void;
}The method init(params) takes a params object with the interface IStatusPanelParams.
Properties available on the IStatusPanelParams<TData = any, TContext = any> interface.
string |
The grid api. |
Application context as set on gridOptions.context. |
Custom Panels are configured alongside Provided Panels.
const gridOptions = {
statusBar: {
statusPanels: [
{
statusPanel: MyStatusBarComponent
},
{
statusPanel: 'agAggregationComponent'
}
]
},
// ...other properties
}Custom Panels can listen to grid events to react to grid changes. An easy way to listen to grid events from inside a Status Panel is using the API provided via props.
class ClickableStatusBarComponent() {
init(params) {
this.params = params;
// Remove event listener when destroyed
params.api.addEventListener('modelUpdated', () => {
// On the modelUpdated event rows will be available
this.updateStatusBar();
});
}
updateStatusBar() { ... }
} Accessing Instances Copy Link
Use the grid API getStatusPanel(key) to access a panel instance. This can be used to expose Custom Panels to the application.
Gets the status panel instance corresponding to the supplied id. |
Clicking on the button in the status bar will log the number of selected rows to the developer console.
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
RowSelectionModule,
TextEditorModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { ClickableStatusBarComponent } from "./clickableStatusBarComponent";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
export interface IClickableStatusBar {
setVisible(visible: boolean): void;
isVisible(): boolean;
}
const columnDefs: ColDef[] = [
{
field: "row",
},
{
field: "name",
},
];
function toggleStatusBarComp() {
const statusBarComponent =
gridApi!.getStatusPanel<IClickableStatusBar>("statusBarCompKey")!;
statusBarComponent.setVisible(!statusBarComponent.isVisible());
}
let gridApi: GridApi;
const gridOptions: GridOptions = {
defaultColDef: {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
},
columnDefs: columnDefs,
rowData: [
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
],
rowSelection: {
mode: "multiRow",
},
statusBar: {
statusPanels: [
{
statusPanel: ClickableStatusBarComponent,
key: "statusBarCompKey",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
},
},
],
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).toggleStatusBarComp = toggleStatusBarComp;
}
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
import type { IStatusPanelComp, IStatusPanelParams } from 'ag-grid-community';
export class ClickableStatusBarComponent implements IStatusPanelComp {
params!: IStatusPanelParams;
eGui!: HTMLDivElement;
buttonListener: any;
visible!: boolean;
eButton!: HTMLButtonElement;
init(params: IStatusPanelParams) {
this.params = params;
this.visible = true;
this.eGui = document.createElement('div');
this.eGui.className = 'ag-status-name-value';
const label = document.createElement('span');
label.textContent = 'Status Bar Component ';
this.eGui.appendChild(label);
this.eButton = document.createElement('button');
this.buttonListener = this.onButtonClicked.bind(this);
this.eButton.addEventListener('click', this.buttonListener);
this.eButton.textContent = 'Click Me';
this.eGui.appendChild(this.eButton);
}
getGui() {
return this.eGui;
}
destroy() {
this.eButton.removeEventListener('click', this.buttonListener);
}
onButtonClicked() {
console.log('Selected Row Count: ' + this.params.api.getSelectedRows().length);
}
setVisible(visible: boolean) {
this.visible = visible;
this.eGui.style.display = this.visible ? 'block' : 'none';
}
isVisible() {
return this.visible;
}
}
<button onclick="toggleStatusBarComp()" style="margin-bottom: 10px">Toggle Status Bar Component</button>
<div id="myGrid" style="height: 90%"></div>

The Status Bar appears below the grid and contains Status Bar Panels. Panels can be Grid Provided Panels or Custom Status Bar Panels.
Configure the Status Bar with the statusBar grid property. The property takes a list of Status Bar Panels.
const statusBar = useMemo(() => {
return {
statusPanels: [
{ statusPanel: 'agTotalAndFilteredRowCountComponent' },
{ statusPanel: 'agTotalRowCountComponent' },
{ statusPanel: 'agFilteredRowCountComponent' },
{ statusPanel: 'agSelectedRowCountComponent' },
{ statusPanel: 'agAggregationComponent' }
]
};
}, []);
<AgGridReact statusBar={statusBar} />Some Status Panels only show when a Cell Selection is present.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
NumberFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age", filter: "agNumberColumnFilter" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
filter: true,
};
}, []);
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return { mode: "multiRow" };
}, []);
const statusBar = useMemo<StatusBar>(() => {
return {
statusPanels: [
{ statusPanel: "agTotalAndFilteredRowCountComponent" },
{ statusPanel: "agTotalRowCountComponent" },
{ statusPanel: "agFilteredRowCountComponent" },
{ statusPanel: "agSelectedRowCountComponent" },
{ statusPanel: "agAggregationComponent" },
],
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowSelection={rowSelection}
cellSelection={true}
statusBar={statusBar}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Provided Panels Copy Link
The Status Bar Panels provided by the grid are as follows:
agTotalRowCountComponent: Provides the total row count.agTotalAndFilteredRowCountComponent: Provides the total and filtered row count.agFilteredRowCountComponent: Provides the filtered row count.agSelectedRowCountComponent: Provides the selected row count.agAggregationComponent: Provides aggregations on the selected range.
Configuration Copy Link
The align property can be left, center or right (default).
The key is used for Accessing Panel Instances via the grid API getStatusPanel(key). This can be useful for interacting with Custom Panels.
Additional props are passed to Status Panels using statusPanelParams. The provided panel agAggregationComponent can have aggFuncs passed.
const statusBar = useMemo(() => {
return {
statusPanels: [
{
key: 'aUniqueString',
statusPanel: 'agTotalRowCountComponent',
align: 'left'
},
{
statusPanel: 'agAggregationComponent',
statusPanelParams: {
// possible values are: 'count', 'sum', 'min', 'max', 'avg'
aggFuncs: ['avg', 'sum']
}
}
]
};
}, []);
<AgGridReact statusBar={statusBar} />Labels (e.g. "Rows", "Total Rows", "Average") and number formatting are changed using the grid's Localisation.
The Aggregation Panel agAggregationComponent works with number and bigint values. When bigint values are present, avg uses integer division and discards the fractional part.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
StatusBar,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const statusBar = useMemo<StatusBar>(() => {
return {
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["avg", "sum"],
},
},
],
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
statusBar={statusBar}
cellSelection={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; The Status Bar sizes its height to fit content. When no panels are visible, the Status Bar will have zero height (not be shown). Add CSS to have a fixed height on the Status Bar.
.ag-status-bar {
min-height: 35px;
} Value Formatting Copy Link
Each Status Bar Panel can have its displayed values customised using a valueFormatter function. This allows for formatting values before they are rendered in the UI.
The valueFormatter function is provided in the statusPanelParams object.
const statusBar = useMemo(() => {
return {
statusPanels: [
{
statusPanel: 'agTotalAndFilteredRowCountComponent',
statusPanelParams: {
valueFormatter: (statusPanelValueFormatterParams) => {
const { value } = statusPanelValueFormatterParams;
if (value > 1000) {
return value / 1000 + ' K';
}
return String(value);
}
}
},
]
};
}, []);
<AgGridReact statusBar={statusBar} /> IProvidedStatusPanelParams Copy Link
Properties available on the IProvidedStatusPanelParams interface.
(params: IStatusPanelValueFormatterParams) => string |
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
IStatusPanelValueFormatterParams,
ModuleRegistry,
StatusBar,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const statusBar = useMemo<StatusBar>(() => {
return {
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
statusPanelParams: {
valueFormatter: (params: IStatusPanelValueFormatterParams) => {
const { value, bigintValue } = params;
if (bigintValue != null) {
return bigintValue.toString();
}
if (typeof value === "number" && value > 1000) {
return (value / 1000).toFixed(1) + " K";
}
return String(value);
},
},
},
],
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
statusBar={statusBar}
cellSelection={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Custom Panels Copy Link
Applications that are using Server-side Data or which require bespoke Status Bar Panels can provide their own custom Status Bar panels.
Clicking on the button in the status bar will log the number of selected rows to the developer console.
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
RowSelectionOptions,
StatusPanelDef,
} from "ag-grid-community";
import {
ClientSideRowModelModule,
EventApiModule,
RowApiModule,
RowSelectionModule,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import ClickableStatusBarComponent from "./clickableStatusBarComponent";
import CountStatusBarComponent from "./countStatusBarComponent";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
EventApiModule,
TextEditorModule,
TextFilterModule,
RowSelectionModule,
RowApiModule,
ClientSideRowModelModule,
StatusBarModule,
CellSelectionModule,
];
const rowSelection: RowSelectionOptions = {
mode: "multiRow",
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>([
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
]);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "row",
},
{
field: "name",
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
}, []);
const statusBar = useMemo<{
statusPanels: StatusPanelDef[];
}>(() => {
return {
statusPanels: [
{
statusPanel: CountStatusBarComponent,
},
{
statusPanel: ClickableStatusBarComponent,
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
},
},
],
};
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowSelection={rowSelection}
statusBar={statusBar}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
background-color: lightgrey;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
.status-bar-input {
height: initial !important;
}
import React from "react";
import type { CustomStatusPanelProps } from "ag-grid-react";
export default (props: CustomStatusPanelProps) => {
const onClick = () => {
console.log("Selected Row Count: " + props.api.getSelectedRows().length);
};
return (
<div className="ag-status-name-value">
<span>
Status Bar Component
<input
type="button"
className="status-bar-input"
onClick={() => onClick()}
value="Click Me"
/>
</span>
</div>
);
};
import React, { useEffect, useState } from "react";
import type { CustomStatusPanelProps } from "ag-grid-react";
export default (props: CustomStatusPanelProps) => {
const [count, setCount] = useState(0);
useEffect(() => {
const onRowCountChanged = () => {
setCount(props.api.getDisplayedRowCount());
};
props.api.addEventListener("rowDataUpdated", onRowCountChanged);
// Get the initial count
onRowCountChanged();
return () => {
props.api.removeEventListener("rowDataUpdated", onRowCountChanged);
};
}, []);
return (
<div className="ag-status-name-value">
<span className="component">Row Count Component </span>
<span className="ag-status-name-value-value">{count}</span>
</div>
);
};
When a status bar component is instantiated then the following will be made available on props.
Properties available on the CustomStatusPanelProps<TData = any, TContext = any> interface.
string |
The grid api. |
Application context as set on gridOptions.context. |
Custom Panels are configured alongside Provided Panels.
<AgGridReact
statusBar: {{
statusPanels: [
{
statusPanel: MyStatusBarComponent
},
{
statusPanel: 'agAggregationComponent'
}
]
}}
...other props...
/>Custom Panels can listen to grid events to react to grid changes. An easy way to listen to grid events from inside a Status Panel is using the API provided via props.
const updateStatusBar = () => { ... }
useEffect(() => {
props.api.addEventListener('modelUpdated', updateStatusBar);
// Remove event listener when destroyed
return () => {
if (!props.api.isDestroyed()) {
props.api.removeEventListener('modelUpdated', updateStatusBar);
}
}
}, []); Accessing Instances Copy Link
Use the grid API getStatusPanel(key) to access a panel instance. This can be used to expose Custom Panels to the application.
Gets the status panel instance corresponding to the supplied id. |
Clicking on the button in the status bar will log the number of selected rows to the developer console.
'use client';
import React, {
StrictMode,
useCallback,
useMemo,
useRef,
useState,
} from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
IStatusPanel,
RowSelectionOptions,
StatusPanelDef,
} from "ag-grid-community";
import {
ClientSideRowModelModule,
RowSelectionModule,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact, getInstance } from "ag-grid-react";
import ClickableStatusBarComponent from "./clickableStatusBarComponent";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
StatusBarModule,
CellSelectionModule,
];
export interface IClickableStatusBar extends IStatusPanel {
setVisible(visible: boolean): void;
isVisible(): boolean;
}
const rowSelection: RowSelectionOptions = {
mode: "multiRow",
};
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "90%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>([
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
]);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "row",
},
{
field: "name",
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
}, []);
const statusBar = useMemo<{
statusPanels: StatusPanelDef[];
}>(() => {
return {
statusPanels: [
{
statusPanel: ClickableStatusBarComponent,
key: "statusBarCompKey",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
},
},
],
};
}, []);
const toggleStatusBarComp = useCallback(() => {
getInstance(
gridRef.current!.api.getStatusPanel<IClickableStatusBar>(
"statusBarCompKey",
)!,
(statusBarComponent) => {
statusBarComponent!.setVisible(!statusBarComponent!.isVisible());
},
);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<button onClick={toggleStatusBarComp} style={{ marginBottom: "10px" }}>
Toggle Status Bar Component
</button>
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowSelection={rowSelection}
statusBar={statusBar}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
import React, { forwardRef, useImperativeHandle, useState } from "react";
import type { CustomStatusPanelProps } from "ag-grid-react";
export default forwardRef((props: CustomStatusPanelProps, ref) => {
const [visible, setVisible] = useState(true);
const onClick = () => {
console.log("Selected Row Count: " + props.api.getSelectedRows().length);
};
useImperativeHandle(ref, () => {
return {
setVisible: (visible: boolean) => {
setVisible(visible);
},
isVisible: () => {
return visible;
},
};
});
if (visible) {
return (
<div className="container">
<div>
<span className="component">
Status Bar Component
<input type="button" onClick={() => onClick()} value="Click Me" />
</span>
</div>
</div>
);
}
return null;
});

The Status Bar appears below the grid and contains Status Bar Panels. Panels can be Grid Provided Panels or Custom Status Bar Panels.
Configure the Status Bar with the statusBar grid property. The property takes a list of Status Bar Panels.
<ag-grid-angular
[statusBar]="statusBar"
/* other grid options ... */ />
this.statusBar = {
statusPanels: [
{ statusPanel: 'agTotalAndFilteredRowCountComponent' },
{ statusPanel: 'agTotalRowCountComponent' },
{ statusPanel: 'agFilteredRowCountComponent' },
{ statusPanel: 'agSelectedRowCountComponent' },
{ statusPanel: 'agAggregationComponent' }
]
};Some Status Panels only show when a Cell Selection is present.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowSelection]="rowSelection"
[cellSelection]="true"
[statusBar]="statusBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age", filter: "agNumberColumnFilter" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
filter: true,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
};
statusBar: StatusBar = {
statusPanels: [
{ statusPanel: "agTotalAndFilteredRowCountComponent" },
{ statusPanel: "agTotalRowCountComponent" },
{ statusPanel: "agFilteredRowCountComponent" },
{ statusPanel: "agSelectedRowCountComponent" },
{ statusPanel: "agAggregationComponent" },
],
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Provided Panels Copy Link
The Status Bar Panels provided by the grid are as follows:
agTotalRowCountComponent: Provides the total row count.agTotalAndFilteredRowCountComponent: Provides the total and filtered row count.agFilteredRowCountComponent: Provides the filtered row count.agSelectedRowCountComponent: Provides the selected row count.agAggregationComponent: Provides aggregations on the selected range.
Configuration Copy Link
The align property can be left, center or right (default).
The key is used for Accessing Panel Instances via the grid API getStatusPanel(key). This can be useful for interacting with Custom Panels.
Additional props are passed to Status Panels using statusPanelParams. The provided panel agAggregationComponent can have aggFuncs passed.
<ag-grid-angular
[statusBar]="statusBar"
/* other grid options ... */ />
this.statusBar = {
statusPanels: [
{
key: 'aUniqueString',
statusPanel: 'agTotalRowCountComponent',
align: 'left'
},
{
statusPanel: 'agAggregationComponent',
statusPanelParams: {
// possible values are: 'count', 'sum', 'min', 'max', 'avg'
aggFuncs: ['avg', 'sum']
}
}
]
};Labels (e.g. "Rows", "Total Rows", "Average") and number formatting are changed using the grid's Localisation.
The Aggregation Panel agAggregationComponent works with number and bigint values. When bigint values are present, avg uses integer division and discards the fractional part.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
StatusBar,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[statusBar]="statusBar"
[cellSelection]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
statusBar: StatusBar = {
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["avg", "sum"],
},
},
],
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The Status Bar sizes its height to fit content. When no panels are visible, the Status Bar will have zero height (not be shown). Add CSS to have a fixed height on the Status Bar.
.ag-status-bar {
min-height: 35px;
} Value Formatting Copy Link
Each Status Bar Panel can have its displayed values customised using a valueFormatter function. This allows for formatting values before they are rendered in the UI.
The valueFormatter function is provided in the statusPanelParams object.
<ag-grid-angular
[statusBar]="statusBar"
/* other grid options ... */ />
this.statusBar = {
statusPanels: [
{
statusPanel: 'agTotalAndFilteredRowCountComponent',
statusPanelParams: {
valueFormatter: (statusPanelValueFormatterParams) => {
const { value } = statusPanelValueFormatterParams;
if (value > 1000) {
return value / 1000 + ' K';
}
return String(value);
}
}
},
]
}; IProvidedStatusPanelParams Copy Link
Properties available on the IProvidedStatusPanelParams interface.
(params: IStatusPanelValueFormatterParams) => string |
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IStatusPanelValueFormatterParams,
ModuleRegistry,
StatusBar,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[statusBar]="statusBar"
[cellSelection]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
statusBar: StatusBar = {
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
statusPanelParams: {
valueFormatter: (params: IStatusPanelValueFormatterParams) => {
const { value, bigintValue } = params;
if (bigintValue != null) {
return bigintValue.toString();
}
if (typeof value === "number" && value > 1000) {
return (value / 1000).toFixed(1) + " K";
}
return String(value);
},
},
},
],
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Custom Panels Copy Link
Applications that are using Server-side Data or which require bespoke Status Bar Panels can provide their own custom Status Bar panels.
Clicking on the button in the status bar will log the number of selected rows to the developer console.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
EventApiModule,
GridApi,
GridOptions,
GridReadyEvent,
IAggregationStatusPanelParams,
ModuleRegistry,
RowApiModule,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
RowApiModule,
EventApiModule,
]);
import { ClickableStatusBarComponent } from "./clickable-status-bar-component.component";
import { CountStatusBarComponent } from "./count-status-bar-component.component";
@Component({
selector: "my-app",
standalone: true,
imports: [
AgGridAngular,
ClickableStatusBarComponent,
CountStatusBarComponent,
],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[rowSelection]="rowSelection"
[statusBar]="statusBar"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "row",
},
{
field: "name",
},
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
rowData: any[] | null = [
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
];
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
};
statusBar: StatusBar = {
statusPanels: [
{
statusPanel: CountStatusBarComponent,
},
{
statusPanel: ClickableStatusBarComponent,
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
} as IAggregationStatusPanelParams,
},
],
};
}
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
background-color: lightgrey;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
.status-bar-input {
height: initial !important;
}
import { Component } from '@angular/core';
import type { IStatusPanelAngularComp } from 'ag-grid-angular';
import type { IStatusPanelParams } from 'ag-grid-community';
@Component({
standalone: true,
template: `
<div class="ag-status-name-value">
<span class="component">
Status Bar Component
<input class="status-bar-input" type="button" (click)="onClick()" value="Click Me" />
</span>
</div>
`,
})
export class ClickableStatusBarComponent implements IStatusPanelAngularComp {
private params!: IStatusPanelParams;
agInit(params: IStatusPanelParams): void {
this.params = params;
}
onClick(): void {
console.log('Selected Row Count: ' + this.params.api.getSelectedRows().length);
}
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { IStatusPanelAngularComp } from 'ag-grid-angular';
import type { IStatusPanelParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<div class="ag-status-name-value">
<span>Row Count Component :</span>
<span class="ag-status-name-value-value">{{ count() }}</span>
</div>
`,
})
export class CountStatusBarComponent implements IStatusPanelAngularComp {
count = signal<number | undefined>(undefined);
agInit(params: IStatusPanelParams): void {
params.api.addEventListener('rowDataUpdated', (event) => {
this.count.set(event.api.getDisplayedRowCount());
});
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Implement this interface to create a status bar component.
interface IStatusPanelAngularComp {
// mandatory methods
// The agInit(params) method is called on the status bar component once.
// See below for details on the parameters.
agInit(params: IStatusPanelParams): void;
// optional methods
// Called when the `statusBar` grid option is updated.
// If this method returns `true`, the grid assumes that
// the status panel has updated with the latest params,
// and takes no further action. If this method returns `false`,
// or is not implemented, the grid will destroy and
// recreate the status panel.
refresh(params: IStatusPanelParams): boolean;
}The agInit(params) method takes a params object with the items listed below:
Properties available on the IStatusPanelParams<TData = any, TContext = any> interface.
string |
The grid api. |
Application context as set on gridOptions.context. |
Custom Panels are configured alongside Provided Panels.
this.gridOptions = {
statusBar: {
statusPanels: [
{
statusPanel: MyStatusBarComponent
},
{
statusPanel: 'agAggregationComponent'
}
]
},
// ...other properties
}Custom Panels can listen to grid events to react to grid changes. An easy way to listen to grid events from inside a Status Panel is using the API provided via props.
class ClickableStatusBarComponent() {
agInit(params: IStatusPanelParams) {
this.params = params;
// Remove event listener when destroyed
params.api.addEventListener('modelUpdated', () => {
// On the modelUpdated event rows will be available
this.updateStatusBar();
});
}
updateStatusBar() { ... }
} Accessing Instances Copy Link
Use the grid API getStatusPanel(key) to access a panel instance. This can be used to expose Custom Panels to the application.
Gets the status panel instance corresponding to the supplied id. |
Clicking on the button in the status bar will log the number of selected rows to the developer console.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
import { ClickableStatusBarComponent } from "./clickable-status-bar-component.component";
export interface IClickableStatusBar {
setVisible(visible: boolean): void;
isVisible(): boolean;
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, ClickableStatusBarComponent],
template: `<button
(click)="toggleStatusBarComp()"
style="margin-bottom: 10px"
>
Toggle Status Bar Component
</button>
<ag-grid-angular
style="width: 100%; height: 90%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[rowSelection]="rowSelection"
[statusBar]="statusBar"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
private gridApi!: GridApi;
columnDefs: ColDef[] = [
{
field: "row",
},
{
field: "name",
},
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
rowData: any[] | null = [
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
];
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
};
statusBar: StatusBar = {
statusPanels: [
{
statusPanel: ClickableStatusBarComponent,
key: "statusBarCompKey",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
},
},
],
};
toggleStatusBarComp() {
const statusBarComponent =
this.gridApi.getStatusPanel<IClickableStatusBar>("statusBarCompKey")!;
statusBarComponent.setVisible(!statusBarComponent.isVisible());
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
}
}
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
import { Component } from '@angular/core';
import type { IStatusPanelAngularComp } from 'ag-grid-angular';
import type { IStatusPanelParams } from 'ag-grid-community';
@Component({
standalone: true,
template: `
@if (visible) {
<div class="container">
<div>
<span class="component"
>Status Bar Component <input type="button" (click)="onClick()" value="Click Me"
/></span>
</div>
</div>
}
`,
})
export class ClickableStatusBarComponent implements IStatusPanelAngularComp {
public params!: IStatusPanelParams;
public visible = true;
agInit(params: IStatusPanelParams): void {
this.params = params;
}
onClick(): void {
console.log('Selected Row Count: ' + this.params.api.getSelectedRows().length);
}
setVisible(visible: boolean) {
this.visible = visible;
}
isVisible(): boolean {
return this.visible;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});

The Status Bar appears below the grid and contains Status Bar Panels. Panels can be Grid Provided Panels or Custom Status Bar Panels.
Configure the Status Bar with the statusBar grid property. The property takes a list of Status Bar Panels.
<ag-grid-vue
:statusBar="statusBar"
/* other grid options ... */>
</ag-grid-vue>
this.statusBar = {
statusPanels: [
{ statusPanel: 'agTotalAndFilteredRowCountComponent' },
{ statusPanel: 'agTotalRowCountComponent' },
{ statusPanel: 'agFilteredRowCountComponent' },
{ statusPanel: 'agSelectedRowCountComponent' },
{ statusPanel: 'agAggregationComponent' }
]
};Some Status Panels only show when a Cell Selection is present.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
NumberFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowSelection="rowSelection"
:cellSelection="true"
:statusBar="statusBar"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age", filter: "agNumberColumnFilter" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
filter: true,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
});
const statusBar = ref<StatusBar>({
statusPanels: [
{ statusPanel: "agTotalAndFilteredRowCountComponent" },
{ statusPanel: "agTotalRowCountComponent" },
{ statusPanel: "agFilteredRowCountComponent" },
{ statusPanel: "agSelectedRowCountComponent" },
{ statusPanel: "agAggregationComponent" },
],
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
statusBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Provided Panels Copy Link
The Status Bar Panels provided by the grid are as follows:
agTotalRowCountComponent: Provides the total row count.agTotalAndFilteredRowCountComponent: Provides the total and filtered row count.agFilteredRowCountComponent: Provides the filtered row count.agSelectedRowCountComponent: Provides the selected row count.agAggregationComponent: Provides aggregations on the selected range.
Configuration Copy Link
The align property can be left, center or right (default).
The key is used for Accessing Panel Instances via the grid API getStatusPanel(key). This can be useful for interacting with Custom Panels.
Additional props are passed to Status Panels using statusPanelParams. The provided panel agAggregationComponent can have aggFuncs passed.
<ag-grid-vue
:statusBar="statusBar"
/* other grid options ... */>
</ag-grid-vue>
this.statusBar = {
statusPanels: [
{
key: 'aUniqueString',
statusPanel: 'agTotalRowCountComponent',
align: 'left'
},
{
statusPanel: 'agAggregationComponent',
statusPanelParams: {
// possible values are: 'count', 'sum', 'min', 'max', 'avg'
aggFuncs: ['avg', 'sum']
}
}
]
};Labels (e.g. "Rows", "Total Rows", "Average") and number formatting are changed using the grid's Localisation.
The Aggregation Panel agAggregationComponent works with number and bigint values. When bigint values are present, avg uses integer division and discards the fractional part.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
StatusBar,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:statusBar="statusBar"
:cellSelection="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const statusBar = ref<StatusBar>({
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["avg", "sum"],
},
},
],
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
statusBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The Status Bar sizes its height to fit content. When no panels are visible, the Status Bar will have zero height (not be shown). Add CSS to have a fixed height on the Status Bar.
.ag-status-bar {
min-height: 35px;
} Value Formatting Copy Link
Each Status Bar Panel can have its displayed values customised using a valueFormatter function. This allows for formatting values before they are rendered in the UI.
The valueFormatter function is provided in the statusPanelParams object.
<ag-grid-vue
:statusBar="statusBar"
/* other grid options ... */>
</ag-grid-vue>
this.statusBar = {
statusPanels: [
{
statusPanel: 'agTotalAndFilteredRowCountComponent',
statusPanelParams: {
valueFormatter: (statusPanelValueFormatterParams) => {
const { value } = statusPanelValueFormatterParams;
if (value > 1000) {
return value / 1000 + ' K';
}
return String(value);
}
}
},
]
}; IProvidedStatusPanelParams Copy Link
Properties available on the IProvidedStatusPanelParams interface.
(params: IStatusPanelValueFormatterParams) => string |
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IStatusPanelValueFormatterParams,
ModuleRegistry,
StatusBar,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:statusBar="statusBar"
:cellSelection="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 180 },
{ field: "sport", minWidth: 200 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const statusBar = ref<StatusBar>({
statusPanels: [
{
statusPanel: "agTotalRowCountComponent",
align: "left",
statusPanelParams: {
valueFormatter: (params: IStatusPanelValueFormatterParams) => {
const { value, bigintValue } = params;
if (bigintValue != null) {
return bigintValue.toString();
}
if (typeof value === "number" && value > 1000) {
return (value / 1000).toFixed(1) + " K";
}
return String(value);
},
},
},
],
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
statusBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Custom Panels Copy Link
Applications that are using Server-side Data or which require bespoke Status Bar Panels can provide their own custom Status Bar panels.
Clicking on the button in the status bar will log the number of selected rows to the developer console.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
EventApiModule,
GridApi,
GridOptions,
GridReadyEvent,
IAggregationStatusPanelParams,
ModuleRegistry,
RowApiModule,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import ClickableStatusBarComponent from "./clickableStatusBarComponentVue";
import CountStatusBarComponent from "./countStatusBarComponentVue";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
RowApiModule,
EventApiModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:rowSelection="rowSelection"
:statusBar="statusBar"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
ClickableStatusBarComponent,
CountStatusBarComponent,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "row",
},
{
field: "name",
},
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
filter: true,
});
const rowData = ref<any[] | null>([
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
]);
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
});
const statusBar = ref<StatusBar>({
statusPanels: [
{
statusPanel: "CountStatusBarComponent",
},
{
statusPanel: "ClickableStatusBarComponent",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
} as IAggregationStatusPanelParams,
},
],
});
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
rowSelection,
statusBar,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
background-color: lightgrey;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
.status-bar-input {
height: initial !important;
}
export default {
template: `
<div class="ag-status-name-value">
<span>Status Bar Component
<input type="button" class="status-bar-input" v-on:click="onClick" value="Click Me"/>
</span>
</div>
`,
data: function () {
return {};
},
methods: {
onClick() {
console.log('Selected Row Count: ' + this.params.api.getSelectedRows().length);
},
},
};
export default {
template: `
<div class="ag-status-name-value">
<span>Row Count Component :</span>
<span class="ag-status-name-value-value">{{ count }}</span>
</div>
`,
data: function () {
return {
count: null,
};
},
beforeMount() {
this.params.api.addEventListener('rowDataUpdated', () => {
this.count = this.params.api.getDisplayedRowCount();
});
},
methods: {
onGridReady(params) {},
},
};
Any valid Vue component can be a status bar component, however it is also possible to implement the following optional methods:
interface IStatusPanel {
// Called when the `statusBar` grid option is updated.
// If this method returns `true`, the grid assumes that
// the status panel has updated with the latest params,
// and takes no further action. If this method returns `false`,
// or is not implemented, the grid will destroy and
// recreate the status panel.
refresh(params: IStatusPanelParams): boolean;
// Gets called when the grid is destroyed.
// If your status bar components needs to do any cleanup, do it here.
destroy(): void;
}When a custom status bar component is instantiated then the following will be made available on this.params.
Properties available on the IStatusPanelParams<TData = any, TContext = any> interface.
string |
The grid api. |
Application context as set on gridOptions.context. |
Custom Panels are configured alongside Provided Panels.
this.gridOptions = {
statusBar: {
statusPanels: [
{
statusPanel: 'myStatusBarComponent'
},
{
statusPanel: 'agAggregationComponent'
}
]
},
// ...other properties
}Custom Panels can listen to grid events to react to grid changes. An easy way to listen to grid events from inside a Status Panel is using the API provided via props.
export default {
methods: {
updateStatusBar() { ... },
},
created() {
// Remove event listener when destroyed
this.params.api.addEventListener(
'modelUpdated',
this.updateStatusBar.bind(this)
);
},
}; Accessing Instances Copy Link
Use the grid API getStatusPanel(key) to access a panel instance. This can be used to expose Custom Panels to the application.
Gets the status panel instance corresponding to the supplied id. |
Clicking on the button in the status bar will log the number of selected rows to the developer console.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowSelectionModule,
RowSelectionOptions,
StatusBar,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, StatusBarModule } from "ag-grid-enterprise";
import ClickableStatusBarComponent from "./clickableStatusBarComponentVue";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
RowSelectionModule,
ClientSideRowModelModule,
CellSelectionModule,
StatusBarModule,
]);
export interface IClickableStatusBar {
setVisible(visible: boolean): void;
isVisible(): boolean;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<button v-on:click="toggleStatusBarComp()" style="margin-bottom: 10px">Toggle Status Bar Component</button>
<ag-grid-vue
style="width: 100%; height: 90%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:rowSelection="rowSelection"
:statusBar="statusBar"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
ClickableStatusBarComponent,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "row",
},
{
field: "name",
},
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
filter: true,
});
const rowData = ref<any[] | null>([
{ row: "Row 1", name: "Michael Phelps" },
{ row: "Row 2", name: "Natalie Coughlin" },
{ row: "Row 3", name: "Aleksey Nemov" },
{ row: "Row 4", name: "Alicia Coutts" },
{ row: "Row 5", name: "Missy Franklin" },
{ row: "Row 6", name: "Ryan Lochte" },
{ row: "Row 7", name: "Allison Schmitt" },
{ row: "Row 8", name: "Natalie Coughlin" },
{ row: "Row 9", name: "Ian Thorpe" },
{ row: "Row 10", name: "Bob Mill" },
{ row: "Row 11", name: "Willy Walsh" },
{ row: "Row 12", name: "Sarah McCoy" },
{ row: "Row 13", name: "Jane Jack" },
{ row: "Row 14", name: "Tina Wills" },
]);
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
});
const statusBar = ref<StatusBar>({
statusPanels: [
{
statusPanel: "ClickableStatusBarComponent",
key: "statusBarCompKey",
},
{
statusPanel: "agAggregationComponent",
statusPanelParams: {
aggFuncs: ["count", "sum"],
},
},
],
});
function toggleStatusBarComp() {
const statusBarComponent =
gridApi.value!.getStatusPanel<IClickableStatusBar>("statusBarCompKey")!;
statusBarComponent.setVisible(!statusBarComponent.isVisible());
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
rowSelection,
statusBar,
onGridReady,
toggleStatusBarComp,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.container {
display: flex;
justify-content: center;
flex-direction: column;
margin: 5px;
padding: 3px 5px 3px 5px;
border-radius: 5px;
}
.component {
margin-left: 5px;
padding-top: 0;
padding-bottom: 0;
}
export default {
template: `
<div class="container" v-if="visible">
<div>
<span class="component">Status Bar Component
<input type="button" v-on:click="onClick" value="Click Me"/>
</span>
</div>
</div>
`,
data: function () {
return {
visible: true,
};
},
methods: {
onClick() {
console.log('Selected Row Count: ' + this.params.api.getSelectedRows().length);
},
setVisible(visible) {
this.visible = visible;
},
isVisible() {
return this.visible;
},
},
};